Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 495)
@@ -8746,6 +8796,54 @@
             (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
           r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-      }
-      break;
+
+        else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+          r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+
+        else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+      }
+      break;
+      //////////////////////
+      case ALLOC_TRT_CONFIG:
+          if((r_config_fsm.read() != CONFIG_TRT_LOCK) and
+             (r_config_fsm.read() != CONFIG_TRT_SET))
+          {
+              if(r_read_fsm.read() == READ_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+              else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                      (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+              else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
+                      (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_CAS;
+
+              else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
+              else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                      (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+                  r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+              else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                  r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+              else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
+                      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+          }
+          break;
+
 
   } // end switch alloc_trt_fsm
@@ -9034,8 +9132,4 @@
   m_write_to_cc_send_srcid_fifo.update( write_to_cc_send_fifo_get, write_to_cc_send_fifo_put,
                                         write_to_cc_send_fifo_srcid );
-#if L1_MULTI_CACHE
-  m_write_to_cc_send_cache_id_fifo.update( write_to_cc_send_fifo_get, write_to_cc_send_fifo_put,
-                                           write_to_cc_send_fifo_cache_id );
-#endif
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -9047,8 +9141,4 @@
   m_config_to_cc_send_srcid_fifo.update( config_to_cc_send_fifo_get, config_to_cc_send_fifo_put,
                                          config_to_cc_send_fifo_srcid );
-#if L1_MULTI_CACHE
-  m_config_to_cc_send_cache_id_fifo.update( config_to_cc_send_fifo_get, config_to_cc_send_fifo_put,
-                                            config_to_cc_send_fifo_cache_id );
-#endif
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -9060,8 +9150,4 @@
   m_xram_rsp_to_cc_send_srcid_fifo.update( xram_rsp_to_cc_send_fifo_get, xram_rsp_to_cc_send_fifo_put,
                                            xram_rsp_to_cc_send_fifo_srcid );
-#if L1_MULTI_CACHE
-  m_xram_rsp_to_cc_send_cache_id_fifo.update( xram_rsp_to_cc_send_fifo_get, xram_rsp_to_cc_send_fifo_put,
-                                              xram_rsp_to_cc_send_fifo_cache_id );
-#endif
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -9073,9 +9159,4 @@
   m_cas_to_cc_send_srcid_fifo.update( cas_to_cc_send_fifo_get, cas_to_cc_send_fifo_put,
                                       cas_to_cc_send_fifo_srcid );
-#if L1_MULTI_CACHE
-  m_cas_to_cc_send_cache_id_fifo.update( cas_to_cc_send_fifo_get, cas_to_cc_send_fifo_put,
-                                         cas_to_cc_send_fifo_cache_id );
-#endif
-
   m_cpt_cycles++;
 
@@ -9089,8 +9170,20 @@
   // Command signals on the p_vci_ixr port
   ////////////////////////////////////////////////////////////
-
-  p_vci_ixr.be      = 0xFF;   // nor transmited to external ram
+  // DATA width is 8 bytes
+  // The following values are not transmitted to XRAM
+  //   p_vci_ixr.be 
+  //   p_vci_ixr.pktid  
+  //   p_vci_ixr.cons 
+  //   p_vci_ixr.wrap 
+  //   p_vci_ixr.contig 
+  //   p_vci_ixr.clen 
+  //   p_vci_ixr.cfixed 
+
+  p_vci_ixr.plen    = 64;
+  p_vci_ixr.srcid   = m_srcid_x;
+  p_vci_ixr.trdid   = r_ixr_cmd_trdid.read();
+  p_vci_ixr.address = (addr_t)r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2);
+  p_vci_ixr.be      = 0xFF; 
   p_vci_ixr.pktid   = 0;
-  p_vci_ixr.srcid   = m_srcid_x;
   p_vci_ixr.cons    = false;
   p_vci_ixr.wrap    = false;
@@ -9098,102 +9191,44 @@
   p_vci_ixr.clen    = 0;
   p_vci_ixr.cfixed  = false;
-  p_vci_ixr.plen    = 64;
-
-  if(r_ixr_cmd_fsm.read() == IXR_CMD_READ)
-  {
-    p_vci_ixr.cmd       = vci_param_ext::CMD_READ;
-    p_vci_ixr.cmdval    = true;
-    p_vci_ixr.address   = (addr_t)(r_read_to_ixr_cmd_nline.read() * m_words * 4);
-    p_vci_ixr.wdata     = 0;
-    p_vci_ixr.trdid     = r_read_to_ixr_cmd_trdid.read();
-    p_vci_ixr.eop       = true;
+
+  if ( (r_ixr_cmd_fsm.read() == IXR_CMD_READ_SEND) or
+       (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_SEND) or
+       (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_SEND) or
+       (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_SEND) or
+       (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_SEND) )
+   {
+      p_vci_ixr.cmdval    = true;
+    
+      if ( r_ixr_cmd_get.read() )  // GET
+      {
+          p_vci_ixr.cmd     = vci_param_ext::CMD_READ;
+          p_vci_ixr.wdata   = 0;
+          p_vci_ixr.eop     = true;
+      }
+      else                         // PUT
+      {
+          size_t word       = r_ixr_cmd_word.read();
+          p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
+          p_vci_ixr.wdata   = ((wide_data_t)(r_ixr_cmd_wdata[word].read()))  |
+                              ((wide_data_t)(r_ixr_cmd_wdata[word+1].read()) << 32);
+          p_vci_ixr.eop     = (word == (m_words-2));
+      }
   }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_CAS)
-  {
-    if(r_cas_to_ixr_cmd_write.read())
-    {
-      size_t word       = r_ixr_cmd_cpt.read();
-      p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
-      p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)( (r_cas_to_ixr_cmd_nline.read() * m_words + word) * 4 );
-      p_vci_ixr.wdata   = ((wide_data_t)(r_cas_to_ixr_cmd_data[word].read()))  |
-                          ((wide_data_t)(r_cas_to_ixr_cmd_data[word+1].read()) << 32);
-      p_vci_ixr.trdid   = r_cas_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-2));
-    }
-    else
-    {
-      p_vci_ixr.cmd     = vci_param_ext::CMD_READ;
-      p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)(r_cas_to_ixr_cmd_nline.read() *m_words*4);
-      p_vci_ixr.wdata   = 0;
-      p_vci_ixr.trdid   = r_cas_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = true;
-    }
-  }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_WRITE)
-  {
-    if(r_write_to_ixr_cmd_write.read())
-    {
-      p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
-      p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)( (r_write_to_ixr_cmd_nline.read() * m_words +
-                                     r_ixr_cmd_cpt.read()) * 4 );
-      p_vci_ixr.wdata   = ((wide_data_t)(r_write_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) |
-                          ((wide_data_t)(r_write_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
-      p_vci_ixr.trdid   = r_write_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-2));
-    }
-    else
-    {
-      p_vci_ixr.cmd     = vci_param_ext::CMD_READ;
-      p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)(r_write_to_ixr_cmd_nline.read() *m_words*4);
-      p_vci_ixr.wdata   = 0;
-      p_vci_ixr.trdid   = r_write_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = true;
-    }
-  }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_XRAM)
-  {
-    p_vci_ixr.cmd       = vci_param_ext::CMD_WRITE;
-    p_vci_ixr.cmdval    = true;
-    p_vci_ixr.address   = (addr_t)( (r_xram_rsp_to_ixr_cmd_nline.read() * m_words +
-                                   r_ixr_cmd_cpt.read()) * 4 );
-    p_vci_ixr.wdata     = ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) |
-                          ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
-    p_vci_ixr.trdid     = r_xram_rsp_to_ixr_cmd_trdid.read();
-    p_vci_ixr.eop       = (r_ixr_cmd_cpt == (m_words-2));
-  } 
-  else if (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_DATA)
+  else if (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_DATA_SEND)
   {
     p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
     p_vci_ixr.cmdval  = true;
-    p_vci_ixr.address = (addr_t)((r_cleanup_to_ixr_cmd_nline.read() * m_words + r_ixr_cmd_cpt.read()) * 4);
-    if (r_cleanup_to_ixr_cmd_ncc_l1_dirty.read()) //if L1 was dirty, the correct data is in the cleanup
-    {
-      p_vci_ixr.wdata   = ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) | 
-          ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
-      if(r_cleanup_to_ixr_cmd_nline.read() == 0x12bb)
-        std::cout << "IXR data dirty = " << std::hex << p_vci_ixr.wdata << std::dec << std::endl;
-    }
-    else //if L1 was not dirty, the data is in the L2
-    {
-      p_vci_ixr.wdata   = ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) | 
-          ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
-      if(r_cleanup_to_ixr_cmd_nline.read() == 0x12bb)
-        std::cout << "IXR data not dirty = " << std::hex << p_vci_ixr.wdata << std::dec << std::endl;
-    }
-    p_vci_ixr.trdid   = r_cleanup_to_ixr_cmd_trdid.read();
-    p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words - 2));
+    /*p_vci_ixr.address = (addr_t)((r_cleanup_to_ixr_cmd_nline.read() * m_words + 
+                                    r_ixr_cmd_word.read()) * 4);*/
+    p_vci_ixr.address = (addr_t)r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2);
+    p_vci_ixr.wdata   = ((wide_data_t)(r_ixr_cmd_wdata[r_ixr_cmd_word.read()].read()) | 
+          ((wide_data_t)(r_ixr_cmd_wdata[r_ixr_cmd_word.read() + 1].read()) << 32));
+    p_vci_ixr.trdid   = r_cleanup_to_ixr_cmd_index.read();
+    p_vci_ixr.eop     = (r_ixr_cmd_word == (m_words - 2));
   }
+
   else
   {
-    p_vci_ixr.cmdval    = false;
-    p_vci_ixr.cmd       = vci_param_ext::CMD_READ;
-    p_vci_ixr.address   = 0;
-    p_vci_ixr.wdata     = 0;
-    p_vci_ixr.trdid     = 0;
-    p_vci_ixr.eop       = false;
+     p_vci_ixr.cmdval    = false;
   }
 
@@ -9202,12 +9237,17 @@
   ////////////////////////////////////////////////////
 
-  if(((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) and
-      (r_ixr_rsp_fsm.read()   == IXR_RSP_TRT_READ)) or
-      (r_ixr_rsp_fsm.read()   == IXR_RSP_ACK))
-
-    p_vci_ixr.rspack = true;
-
-  else
-    p_vci_ixr.rspack = false;
+  if( (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ) or
+      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) )
+  { 
+      p_vci_ixr.rspack = (r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP);
+  }
+  else if (r_ixr_rsp_fsm.read() == IXR_RSP_ACK)
+  {
+      p_vci_ixr.rspack = true;
+  }
+  else // r_ixr_rsp_fsm == IXR_RSP_IDLE
+  {
+      p_vci_ixr.rspack = false;
+  }
 
   ////////////////////////////////////////////////////
@@ -9279,5 +9319,5 @@
     {
       p_vci_tgt.rspval  = true;
-      p_vci_tgt.rdata   = 0;
+      p_vci_tgt.rdata   = r_tgt_cmd_to_tgt_rsp_rdata.read();
       p_vci_tgt.rsrcid  = r_tgt_cmd_to_tgt_rsp_srcid.read();
       p_vci_tgt.rtrdid  = r_tgt_cmd_to_tgt_rsp_trdid.read();
@@ -9904,42 +9944,18 @@
   ////////////////////////////////////////////////////////////////////
 
-  switch(r_cleanup_fsm.read())
+  if ( r_cleanup_fsm.read() == CLEANUP_SEND_CLACK )
   {
-    case CLEANUP_IDLE:
-    case CLEANUP_GET_NLINE:
-    case CLEANUP_DIR_REQ:
-    case CLEANUP_DIR_LOCK:
-    case CLEANUP_DIR_WRITE:
-    case CLEANUP_HEAP_REQ:
-    case CLEANUP_HEAP_LOCK:
-    case CLEANUP_HEAP_SEARCH:
-    case CLEANUP_HEAP_CLEAN:
-    case CLEANUP_HEAP_FREE:
-    case CLEANUP_IVT_LOCK:
-    case CLEANUP_IVT_DECREMENT:
-    case CLEANUP_IVT_CLEAR:
-    case CLEANUP_WRITE_RSP:
-    case CLEANUP_CONFIG_ACK:
-      p_dspin_clack.write = false;
-      p_dspin_clack.eop   = false;
-      p_dspin_clack.data  = 0;
-
-      break;
-
-    case CLEANUP_SEND_CLACK: 
-      {
-        uint8_t cleanup_ack_type;
-        if(r_cleanup_inst.read())
-        {
+      uint8_t cleanup_ack_type;
+      if(r_cleanup_inst.read())
+      {
           cleanup_ack_type = DspinDhccpParam::TYPE_CLACK_INST;
-        }
-        else
-        {
+      }
+      else
+      {
           cleanup_ack_type = DspinDhccpParam::TYPE_CLACK_DATA;
-        }
-
-        uint64_t flit = 0;
-        uint64_t dest =
-          r_cleanup_srcid.read() <<
+      }
+
+      uint64_t flit = 0;
+      uint64_t dest = r_cleanup_srcid.read() <<
           (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
 
@@ -9964,11 +9980,14 @@
             DspinDhccpParam::CLACK_TYPE);
 
-        p_dspin_clack.eop   = true;
-        p_dspin_clack.write = true;
-        p_dspin_clack.data  = flit;
-      }
-      break;
+      p_dspin_clack.eop   = true;
+      p_dspin_clack.write = true;
+      p_dspin_clack.data  = flit;
   }
-
+  else
+  {
+      p_dspin_clack.write = false;
+      p_dspin_clack.eop   = false;
+      p_dspin_clack.data  = 0;
+  }
   ///////////////////////////////////////////////////////////////////
   //  p_dspin_p2m port (CC_RECEIVE FSM)
